---
title: IDL interface rules
slug: Mozilla/Developer_guide/Interface_development_guide/IDL_interface_rules
tags:
  - XPCOM
---
<p>For support and discussion:</p>
<p><span style="font-family: Helvetica;">{{ DiscussionList("dev-embedding", "mozilla.dev.embedding") }}</span></p>
<p>This document describes some dos and don'ts when writing an interface in IDL for Mozilla. For a complete guide, see the <a class="external" href="http://www.mozilla.org/projects/embedding/HowToFreeze.html">How To Freeze</a> document.</p>
<dl> <dt><strong>Rule:</strong> Use interCaps for naming.</dt> <dd>All methods and attributes should begin with a lowercase letter. Every subsequent word in the method or attribute name should be capitalized. Avoid capitalizing first letters and using underscores to separate words.</dd> <dt><strong>Why:</strong> IDL usually follows Java and JavaScript convention, which is intercaps.</dt> <dd>In addition, the first letter of all names are promoted to upper case in C++. The C++ signature is the same whether or not the first letter is capitalized. <ul> <li>Incorrect:</li> </ul> </dd>
</dl>
<pre class="eval">    /* don't capitalize first letters! */
    void OpenFile(in nsIFile file);
    attribute AString Filename;

    /* Avoid underscores! */
    attribute long unknown_entries;
</pre>
<dl> <dd> <ul> <li>Correct:</li> </ul> </dd>
</dl>
<pre class="eval">    void openFile(in nsIFile file);
    attribute AString filename;
    attribute long unknownEntries;
</pre>
<dl> <dt><strong>Rule:</strong> Use attributes wherever you are referring to a single, non-dynamic value.</dt> <dt><strong>Why:</strong> Scripted access to the interface is easier to read.</dt> <dd>Combining two get/set methods into a single attribute also syntactically shows their relevance. Methods also imply some sort of action or side effect. <ul> <li>Incorrect:</li> </ul> </dd>
</dl>
<pre class="eval">    /* These refer to the same value, why make them functions? */
    long getColorValue();
    void setColorValue(in long value);

    /* we just want a getter, but we can still use an attribute!
     * besides, a method implies an action. */
    long brightness();
</pre>
<dl> <dd> <ul> <li>Correct:</li> </ul> </dd>
</dl>
<pre class="eval">    attribute long colorValue;

    readonly attribute long brightness;
</pre>
<dl> <dt><strong>Rule:</strong> Avoid excessively long names, but keep them readable.</dt> <dd>Don't abbreviate words. Avoid names that involve prepositions like "of" or "on" <ul> <li>Incorrect:</li> </ul> </dd> <br>
</dl>
<pre class="eval">    /* seems a bit verbose */
    readonly attribute long numberOfEntries;

    /* why shorten this? is this Attribute? Attrition? */
    long getAttrCount(in ACString name);
</pre>
<dl> <dd> <ul> <li>Correct:</li> </ul> </dd>
</dl>
<pre class="eval">    readonly attribute long entryCount;

    long getAttributeCount(in ACString name);
</pre>
<dl> <dt><strong>Rule:</strong> Use ACString to represent ASCII strings or binary string-like data.</dt> <dt><strong>Why:</strong> The <code>nsA-</code> string classes are more efficient than the "string" type.</dt> <dd>They include the length of the string passed in, and avoid excess allocations. They also allow for subfragments of existing strings without copying, and when assigning one string to another, the underlying buffer can often be shared. <ul> <li>Incorrect:</li> </ul> </dd>
</dl>
<pre class="eval">    /* use the new string classes! */
    void processName(in string name);

    /* high bit will get stripped by XPConnect. is that ok? */
    void fillBuffer(in string data);

    /* new string classes will avoid excess allocation,
     * especially when the caller uses nsCAutoString  */
    void getHeaderValues(out string prefix, out string postfix);
</pre>
<dl> <dd> <ul> <li>Correct:</li> </ul> </dd>
</dl>
<pre class="eval">    void processName(in ACString name);

    void fillBuffer(in ACString data);

    void getHeaderValues(out ACString prefix, out ACString postfix);
</pre>
<dl> <dt><strong>Rule:</strong> Use <code>AString</code> or <code>AUTF8String</code> to represent unicode strings. Avoid the "wstring" type where possible.</dt> <dt><strong>Why:</strong> XPConnect will properly handle unicode conversion.</dt> <dd>In addition, the <code>nsA-</code> string classes are more efficient than the old "wstring" type. <ul> <li>Incorrect:</li> </ul> </dd>
</dl>
<pre class="eval">    /* Even if errorMsg is UTF8, it will get corrupted by XPConnect */
    void displayError(in string errorMsg);

    /* use AString to allow fragment to have a length */
    void parseFragment(in wstring fragment);
</pre>
<dl> <dd> <ul> <li>Correct:</li> </ul> </dd>
</dl>
<pre class="eval">    void displayError(in AUTF8String errorMsg);
    void parseFragment(in AString fragment);
</pre>
<dl> <dt><strong>Rule:</strong> Avoid <code>out</code> parameters</dt> <dd>Avoid them especially when a method has only one out parameter. Use the return value of a function instead.</dd> <dt><strong>Why:</strong> Be script friendly!</dt> <dd><code>out</code> parameters are extra work for scripts, which must create a temporary object to hold the resulting value. <ul> <li>Incorrect:</li> </ul> </dd>
</dl>
<pre class="eval">    /* This will be frustrating to call from a script */
    void getHeaderValue(in ACString header, out AString value);

    /* why isn't this just an attribute? */
    void getLinkSource(out AString source);
</pre>
<dl> <dd> <ul> <li>Correct:</li> </ul> </dd>
</dl>
<pre class="eval">    AString getHeaderValue(in ACString header);
    readonly attribute AString linkSource;
</pre>
<dl> <dt><strong>Rule:</strong> Avoid excess <code>#include</code>s.</dt> <dd>Try to avoid #including extra .h or .idl files unless there are constants or other declarations that are required to compile the .idl file.</dd> <dt><strong>Why:</strong> Excess includes increase dependencies.</dt> <dd>A consumer of an interface does not necessarily use the full interface, and thus may not need a full declaration of every type that the interface uses. <ul> <li>Incorrect:</li> </ul> </dd>
</dl>
<pre class="eval">    /* Can't compile the idl file without this, we derive from nsISupports */
    #include "nsISupports.idl"

    /* does every consumer need to also include this? */
    #include "nsIAtom.idl"

    /* Need this for definition of PRThreadPriority */
    #include "nsIThread.idl"

    interface nsIFoo : nsISupports {
        void setThreadPriority(in nsIThread thread, in PRThreadPriority pri);
        nsIAtom getThreadAtom(in nsIThread thread);
    };
</pre>
<dl> <dd> <ul> <li>Correct:</li> </ul> </dd>
</dl>
<pre class="eval">    /* Can't compile the idl file without this */
    #include "nsISupports.idl"

    /* Need this for definition of PRThreadPriority */
    #include "nsIThread.idl"

    /* Let consumers #include the right header if they need the full definition. */
    interface nsIAtom;

    interface nsIFoo : nsISupports {
        ...
    };
</pre>
<dl> <dt><strong>Rule:</strong> Try to <code>#include</code> only other .idl files.</dt> <dd>If you need access to a type available only in C++, try to predeclare it and rely on C++ consumers to <code>#include</code> the correct header.</dd> <dt><strong>Why:</strong> Easier maintenance of IDL files.</dt> <dd>Generated C headers will differ from the IDL, causing confusion as to what classes have been defined. If you predeclare a type and then <code>#include</code> a .h file in order to get the definition, you may have problems with the generated header if the <code>#include</code>d .h file changes later. Excessive <code>#include</code>s can also cause unnecessary rebuilding when a header changes. <ul> <li>Incorrect:</li> </ul> </dd>
</dl>
<pre class="eval">    %{C
    #include "nsIArena.h" /* C++ only header */
    #include "nsIThread.h" /* Available as nsIThread.idl */
    %}

    /* now have to predeclare nsIThread since IDL doesn't know about it */
    interface nsIThread;
</pre>
<dl> <dd> <ul> <li>Correct:</li> </ul> </dd>
</dl>
<pre class="eval">    /* If header is available (and we really need it) just #include it */
    #include "nsIThread.idl"

    /* otherwise, predeclare it */
    interface nsIArena;

</pre>
<dl> <dt><strong>Rule:</strong> Avoid CID and ContractID declarations in IDL or C++ interface declarations</dt> <dd> </dd><dt><strong>Why:</strong> IDL is for declaring interfaces, and interfaces alone. CIDs and ContractIDs are implementation details.</dt> <dd>Instead of putting these details in an IDL file, put them in a seperate header file. The seperate header file could contain all ContractIDs/CIDs for your module, or you could create a single C++ header which contains the ContractID/CID. <ul> <li>Incorrect:</li> </ul> </dd>
</dl>
<pre class="eval">    // nsIFoo.idl:
    %{C
    // ugh! This doesn't belong in IDL!
    #define NS_FOO_CONTRACTID "@mozilla.org/foo/component;1"
    %}
</pre>
<dl> <dd> <ul> <li>Correct:</li> </ul> </dd>
</dl>
<pre class="eval">    // nsIFoo.idl contains only true IDL
    ...
</pre>
<pre class="eval">    // nsFoo.h contains the ContractID declaration:
    ...
    #define NS_FOO_CONTRACTID "@mozilla.org/foo/component;1"
    ...
</pre>
<div class="originaldocinfo"> <h2 id="Original_Document_Information">Original Document Information</h2> <ul> <li>Author: <a class="link-mailto" href="mailto:alecf@flett.org">Alec Flett</a></li> <li>Last Updated Date: April 27, 2004</li> <li>Copyright Information: Portions of this content are © 1998–2007 by individual mozilla.org contributors; content available under a Creative Commons license | <a class="external" href="http://www.mozilla.org/foundation/licensing/website-content.html">Details</a>.</li> </ul>
</div>
